A blank slate starting point showing the "Hello World" for
the VizHub V3 Runtime Environment, which supports continuous
hot reloading with interactive widgets.

<iframe width="560" height="315" src="https://www.youtube-nocookie.com/embed/bZhWCO-bDek?si=ZjfT29wTiZAdT3aW" title="YouTube video player" frameborder="0" allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share" allowfullscreen></iframe>

Full course playlist:
[YouTube: Constructing Visualization 2024](https://www.youtube.com/watch?v=bZhWCO-bDek&list=PL9yYRbwpkykthTFJl9vYr_C0FCjRIn_7G).

## VizHub Version 3: A New Era in Interactive Coding

The release of VizHub version 3 marks a significant
milestone in the evolution of data visualization tools. This
new version introduces a unique feature set designed to
enhance the coding experience and make data visualization
more interactive and intuitive.

### Interactive Widgets: A Leap Forward in Real-Time Feedback

One of the standout features of VizHub version 3 is its
support for interactive widgets, which enable continuous hot
reloading. This means that developers can see the effects of
their code changes in real-time, without the need for manual
refreshes. By simply holding down the 'Alt' key and dragging
a number in the editor, properties like font size can be
adjusted on the fly, providing immediate visual feedback.

### Simplifying the Entry Point: The Main Function

In a departure from traditional setups, VizHub version 3
does away with the need for an `index.html` file. Instead,
the entry point is a `main` function exported from
`index.js`. This function takes two arguments:

- `container`: A DIV element that has measurable dimensions
  using `clientWidth` and `clientHeight`.
- `options`: An object containing `state` and `setState`,
  where:
  - `state` is initialized as an empty object `{}` and
    stores the application's state.
  - `setState` is a function that can be called with a
    function to create a new state object using immutable
    update patterns.

This streamlined approach is designed to simplify the setup
process and focus more on the creative aspects of coding.

### A Blank Slate Starting Point: "Hello World" for VizHub V3

The "Hello World" example in VizHub version 3 serves as a
blank slate starting point, showcasing the capabilities of
the new runtime environment. This example demonstrates the
simplicity and power of the VizHub V3 Runtime Environment,
providing a foundation for developers to build upon.

### Learning Through Interaction: The Mouse Follower Example

For an interactive example of the capabilities of VizHub
version 3, the
[Mouse Follower](https://vizhub.com/curran/8a349c77f9eb496585faf3c7f61bb0fb?file=index.js)
demonstration provides a hands-on experience. This example
illustrates how developers can create dynamic visualizations
that respond to user input, further highlighting the
platform's emphasis on interactivity and real-time feedback.

### A Humble Yet Powerful Tool

VizHub version 3 represents a humble yet powerful step
forward in the world of interactive coding and data
visualization. Its focus on real-time feedback, simplified
entry points, and interactive examples aims to enhance the
coding experience and make learning more accessible. While
there is still much to explore and improve, this new version
is a testament to the ongoing efforts to make data
visualization more dynamic and engaging.
